## dinit 0.16.1

=== Makefile ===
# Makefile for Dinit.

all: mconfig
	$(MAKE) -C build all
	$(MAKE) -C src all
	$(MAKE) -C doc/manpages all
	@echo "***"
	@echo "*** Build complete; use \"make check\" to run unit tests, \"make check-igr\" for"
	@echo "*** integration tests, or \"make install\" to install."
	@echo "***"

check: mconfig
	$(MAKE) -C src check

check-igr: mconfig
	$(MAKE) -C src check-igr

run-cppcheck:
	$(MAKE) -C src run-cppcheck

install: mconfig
	$(MAKE) -C src install
	$(MAKE) -C doc/manpages install

clean:
	$(MAKE) -C src clean
	$(MAKE) -C build clean
	$(MAKE) -C doc/manpages clean

mconfig:
	@UNAME=`uname`;\
	if [ -f "./configs/mconfig.$$UNAME.sh" ]; then \
	    echo "*** Found auto-configuration script for OS: $$UNAME"; \
	    ( cd ./configs; sh "mconfig.$$UNAME.sh" ) \
	elif [ -f "./configs/mconfig.$$UNAME" ]; then \
	    echo "*** Found configuration for OS: $$UNAME"; \
	    ln -sf "configs/mconfig.$$UNAME" mconfig; \
	else \
	    echo "*** No config available. Please create suitable mconfig file."; \
	    exit 1; \
	fi

=== build/Makefile ===
-include ../mconfig
-include version.conf

all: ../mconfig includes/mconfig.h

../mconfig:
	@echo "*** No mconfig, please run make from top level"
	@false

includes/mconfig.h: ../mconfig tools/mconfig-gen.cc
	$(MAKE) -C tools mconfig-gen
	./tools/mconfig-gen SBINDIR=$(SBINDIR) SYSCONTROLSOCKET=$(SYSCONTROLSOCKET) \
		SHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) VERSION=$(VERSION) \
		$(if $(SUPPORT_CGROUPS),SUPPORT_CGROUPS=$(SUPPORT_CGROUPS),) \
		$(if $(USE_UTMPX),USE_UTMPX=$(USE_UTMPX),) > includes/mconfig.h

clean:
	rm -f includes/mconfig.h
	$(MAKE) -C tools clean

=== src/Makefile ===
include ../mconfig
include ../build/version.conf

STRIPOPTS ?= -s

ifeq ($(BUILD_SHUTDOWN),yes)
  SHUTDOWN=$(SHUTDOWN_PREFIX)shutdown
endif

dinit_objects = dinit.o load-service.o service.o proc-service.o baseproc-service.o control.o dinit-log.o \
		dinit-main.o run-child-proc.o options-processing.o dinit-env.o

objects = $(dinit_objects) dinitctl.o dinitcheck.o shutdown.o dinit-monitor.o

all: dinit dinitctl dinitcheck dinit-monitor $(SHUTDOWN)

../mconfig:
	@echo "*** No mconfig, please run make from top level"
	@false

$(objects): ../build/includes/mconfig.h

dinit: $(dinit_objects)
	$(CXX) -o dinit $(dinit_objects) $(CXXOPTS) $(LDFLAGS)

dinitctl: dinitctl.o
	$(CXX) -o dinitctl dinitctl.o $(CXXOPTS) $(LDFLAGS)

dinitcheck: dinitcheck.o options-processing.o
	$(CXX) -o dinitcheck dinitcheck.o options-processing.o $(CXXOPTS) $(LDFLAGS)

dinit-monitor: dinit-monitor.o
	$(CXX) -o dinit-monitor dinit-monitor.o $(CXXOPTS) $(LDFLAGS)

$(SHUTDOWN_PREFIX)shutdown: shutdown.o
	$(CXX) -o $(SHUTDOWN_PREFIX)shutdown shutdown.o $(CXXOPTS) $(LDFLAGS)

$(objects): %.o: %.cc
	$(CXX) $(CXXOPTS) -MMD -MP -Iincludes -I../dasynq/include -I../build/includes -c $< -o $@

check: ../build/includes/mconfig.h $(dinit_objects)
	$(MAKE) -C tests check

check-igr: dinit dinitctl dinitcheck
	$(MAKE) -C igr-tests check-igr

run-cppcheck:
	cppcheck --std=c++11 -Iincludes -Idasynq --force --enable=all *.cc 2>../cppcheck-report.txt

install: all
	install -d $(DESTDIR)$(SBINDIR)
	install $(STRIPOPTS) dinit dinitctl dinitcheck dinit-monitor $(SHUTDOWN) $(DESTDIR)$(SBINDIR)
ifeq ($(BUILD_SHUTDOWN),yes)
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)halt
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)reboot
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)poweroff
endif

clean:
	rm -f *.o *.d
	rm -f dinit dinitctl dinitcheck shutdown
	$(MAKE) -C tests clean
	$(MAKE) -C igr-tests clean

-include $(objects:.o=.d)

=== build/tools/Makefile ===
-include ../../mconfig

HOSTCXX ?= $(CXX)
HOSTCXXOPTS ?= $(CXXOPTS)
HOSTLDFLAGS ?= $(LDFLAGS)

mconfig-gen: mconfig-gen.cc
	$(HOSTCXX) $(HOSTCXXOPTS) -o mconfig-gen mconfig-gen.cc $(HOSTLDFLAGS)

clean:
	rm -f mconfig-gen

=== doc/manpages/Makefile ===
include ../../mconfig
include ../../build/version.conf

all: generate

generate: dinit.8 dinitctl.8 dinitcheck.8 dinit-monitor.8 dinit-service.5 shutdown.8

install: generate
	mkdir -p "$(DESTDIR)$(MANDIR)/man8"
	install -m644 dinit.8 dinitctl.8 dinitcheck.8 dinit-monitor.8 "$(DESTDIR)$(MANDIR)/man8"
	mkdir -p "$(DESTDIR)$(MANDIR)/man5"
	install -m644 dinit-service.5 "$(DESTDIR)$(MANDIR)/man5"
ifeq ($(BUILD_SHUTDOWN),yes)
	install -m644 shutdown.8 "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)shutdown.8"
	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)halt.8"
	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)reboot.8"
	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)poweroff.8"
endif

clean:
	rm -f dinit.8 dinitctl.8 dinitcheck.8 dinit-monitor.8 dinit-service.5 shutdown.8

html: generate
	./generate-html.sh

dinit.8: dinit.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit.8.m4 > dinit.8

dinitctl.8: dinitctl.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinitctl.8.m4 > dinitctl.8

dinitcheck.8: dinitcheck.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinitcheck.8.m4 > dinitcheck.8

dinit-monitor.8: dinit-monitor.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit-monitor.8.m4 > dinit-monitor.8

dinit-service.5: dinit-service.5.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit-service.5.m4 > dinit-service.5

shutdown.8: shutdown.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) shutdown.8.m4 > shutdown.8

=== src/igr-tests/Makefile ===
include ../../mconfig

check-igr: igr-runner
	./igr-runner

igr-runner: igr-runner.cc
	$(CXX) $(CXXOPTS) igr-runner.cc -o igr-runner

clean:
	rm -f igr-runner basic/basic-ran environ/env-record ps-environ/env-record chain-to/recorded-output
	rm -f restart/basic-ran
	rm -f check-basic/output.txt check-cycle/output.txt
	rm -rf reload1/sd
	rm -rf reload2/sd

=== src/tests/Makefile ===
-include ../../mconfig

objects = tests.o test-dinit.o proctests.o loadtests.o envtests.o test-run-child-proc.o test-bpsys.o
parent_objs = service.o proc-service.o dinit-log.o load-service.o baseproc-service.o dinit-env.o

check: build-tests run-tests

build-tests: prepare-incdir tests proctests loadtests envtests
	$(MAKE) -C cptests build-tests

run-tests: tests proctests loadtests envtests
	./tests
	./proctests
	./loadtests
	./envtests
	$(MAKE) -C cptests run-tests

# Create an "includes" directory populated with a combination of real and mock headers:
prepare-incdir:
	mkdir -p includes
	rm -rf includes/*.h
	cd includes; ln -f ../../includes/*.h .
	cd includes; ln -f ../test-includes/*.h .

tests: $(parent_objs) tests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o tests $(parent_objs) tests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(CXXOPTS) $(LDFLAGS) $(SANITIZEOPTS)

proctests: $(parent_objs) proctests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o proctests $(parent_objs) proctests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(CXXOPTS) $(LDFLAGS) $(SANITIZEOPTS)
	
loadtests: $(parent_objs) loadtests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o loadtests $(parent_objs) loadtests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(CXXOPTS) $(LDFLAGS) $(SANITIZEOPTS)

envtests: $(parent_objs) envtests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o envtests $(parent_objs) envtests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(CXXOPTS) $(LDFLAGS) $(SANITIZEOPTS)

$(objects): %.o: %.cc
	$(CXX) $(CXXOPTS) $(SANITIZEOPTS) -MMD -MP -Iincludes -I../../dasynq/include -I../../build/includes -c $< -o $@

$(parent_objs): %.o: ../%.cc
	$(CXX) $(CXXOPTS) $(SANITIZEOPTS) -MMD -MP -Iincludes -I../../dasynq/include -I../../build/includes -c $< -o $@

clean:
	$(MAKE) -C cptests clean
	rm -f *.o *.d tests proctests loadtests

-include $(objects:.o=.d)
-include $(parent_objs:.o=.d)

=== src/tests/cptests/Makefile ===
-include ../../../mconfig

objects = cptests.o
parent_test_objects = ../test-bpsys.o ../test-dinit.o ../test-run-child-proc.o
parent_objs = control.o dinit-log.o service.o load-service.o proc-service.o baseproc-service.o dinit-env.o

check: build-tests run-tests

build-tests: prepare-incdir cptests

run-tests: cptests
	./cptests
	
# Create an "includes" directory populated with a combination of real and mock headers:
prepare-incdir:
	mkdir -p includes
	rm -rf includes/*.h
	cd includes; ln -f ../../../includes/*.h .
	cd includes; ln -f ../../test-includes/dinit.h .
	cd includes; ln -f ../../test-includes/baseproc-sys.h .

cptests: cptests.o $(parent_objs) $(parent_test_objs)
	$(CXX) -o cptests cptests.o $(parent_test_objects) $(parent_objs) $(CXXOPTS) $(LDFLAGS) $(SANITIZEOPTS)

$(objects): %.o: %.cc
	$(CXX) $(CXXOPTS) $(SANITIZEOPTS) -MMD -MP -Iincludes -I../../../dasynq/include -I../../../build/includes -c $< -o $@

$(parent_objs): %.o: ../../%.cc
	$(CXX) $(CXXOPTS) $(SANITIZEOPTS) -MMD -MP -Iincludes -I../../../dasynq/include -I../../../build/includes -c $< -o $@

clean:
	rm -f *.o *.d cptests


# Experimental LLVM-libFuzzer based fuzzer. "make fuzz" to build; "fuzz corpus" to run (and store
# interesting test data in "corpus" directory).

fuzz_parent_test_objects = $(foreach obj,$(notdir $(parent_test_objects)),fuzz-$(obj))
fuzz_objects = $(foreach obj,$(parent_objs),fuzz-$(obj))

# Create mconfig.h for fuzzing. because fuzz target not runned by top level make; we need to create mconfig.h manually.
../../../mconfig:
	$(MAKE) -C ../../../ mconfig

../../../build/includes/mconfig.h: ../../../mconfig
	$(MAKE) -C ../../../build all

fuzz: prepare-incdir ../../../build/includes/mconfig.h fuzz.cc $(fuzz_parent_test_objects) $(fuzz_objects)
	clang++ -std=c++11 -g -O1 -Iincludes -I../../../dasynq/include -I../../../build/includes/ -fsanitize=fuzzer,address,undefined,leak fuzz.cc $(fuzz_parent_test_objects) $(fuzz_objects) -o fuzz

$(fuzz_parent_test_objects): fuzz-%.o: ../%.cc
	clang -O1 -fsanitize=address,undefined,fuzzer-no-link,leak -MMD -MP -Iincludes -I../../../dasynq/include -I../../../build/includes/ -c $< -o $@

$(fuzz_objects): fuzz-%.o: ../../%.cc
	clang -O1 -fsanitize=address,undefined,fuzzer-no-link,leak -MMD -MP -Iincludes -I../../../dasynq/include -I../../../build/includes/ -c $< -o $@


-include $(objects:.o=.d)
-include $(parent_objects:.o=.d)

=== debian/changelog ===
dinit (0.16.1-1experimental1) UNRELEASED; urgency=medium

  * Initial port from Debian, thanks Mobin!
  * Introduced dinit-init & dinit-init-diversity packages to better control installation options.

 -- ProwlerGr <Prowler73@gmail.com>  Sat, 29 Mar 2025 22:22:22 +0100

dinit (0.16.1-1) unstable; urgency=medium

  * Update to 0.16.1

 -- Mobin Aydinfar <mobin@mobintestserver.ir>  Mon, 6 Mar 2023 19:08:23 +0330

dinit (0.16.0-1) unstable; urgency=medium

  * Initial release. Closes: #1029577
  * Fix many things reported by lintian.

 -- Mobin Aydinfar <mobin@mobintestserver.ir>  Mon, 26 Dec 2022 15:01:41 +0330

=== debian/control ===
Source: dinit
Maintainer: ProwlerGr <Prowler73@gmail.com>
Section: init-diversity
Priority: optional
Standards-Version: 4.6.1.0
Build-Depends: 	debhelper (>= 9), 
				debhelper-compat (= 12), 
				g++ (>= 4.9), 
				m4,
				dh-exec,
Homepage: https://davmac.org/projects/dinit
Vcs-Browser: https://salsa.debian.org/mobin2008/dinit
Vcs-Git: https://salsa.debian.org/mobin2008/dinit.git
Rules-Requires-Root: no

Package: dinit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: dinit,
Recommends: dinit-init-diversity | dinit-init, 
Description: Dinit service monitoring / "init" system
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits. Development goals include
 clean design, robustness, portability, usability,
 and avoiding feature bloat (whilst still handling
 common - and some less-common - use cases).
 Dinit is designed to integrate with rather than subsume or replace
 other system software.

Package: dinit-init
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, dinit,
Conflicts: dinit-init-diversity,
Description: This package installs dinit as the sole or default init system.
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 
 
Package: dinit-init-diversity
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, init-diversity-tools, dinit,
Conflicts: dinit-init,
Recommends: grub-init-diversity,
			sysvinit-init-diversity,
			runit-init-diversity,
			openrc-init-diversity,
			s6-rc-init,
			s6-66-init,
Suggests: systemd-init-diversity,		
Description: This package allows for dinit to be installed alongside other inits.
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits.

## dinit 0.19.1

=== debian/changelog ===
dinit (0.19.1-1) unstable; urgency=medium

  * update to 0.19.1

 -- anticapitalista <antix@operamail.com>  Mon, 17 Mar 2025 16:42:26 +0200

## dinit 0.19.3

=== build/Makefile ===
-include ../mconfig
-include version.conf

all: ../mconfig includes/mconfig.h

../mconfig:
	@echo "*** No mconfig, please run make from top level"
	@false

includes/mconfig.h: ../mconfig tools/mconfig-gen.cc version.conf
	$(MAKE) -C tools mconfig-gen
	./tools/mconfig-gen SBINDIR=$(SBINDIR) SYSCONTROLSOCKET=$(SYSCONTROLSOCKET) \
		SHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) VERSION=$(VERSION) \
		DEFAULT_AUTO_RESTART=$(DEFAULT_AUTO_RESTART) \
		DEFAULT_START_TIMEOUT=$(DEFAULT_START_TIMEOUT) \
		DEFAULT_STOP_TIMEOUT=$(DEFAULT_STOP_TIMEOUT) \
		$(if $(SUPPORT_CGROUPS),SUPPORT_CGROUPS=$(SUPPORT_CGROUPS),) \
		$(if $(USE_UTMPX),USE_UTMPX=$(USE_UTMPX),) \
		$(if $(USE_INITGROUPS),USE_INITGROUPS=$(USE_INITGROUPS),) > includes/mconfig.h

clean:
	rm -f includes/mconfig.h
	$(MAKE) -C tools clean

=== debian/changelog ===
dinit (0.19.3-0experimental3) UNRELEASED; urgency=medium

  * Updated dependency control for dinit-init & dinit-init-diversity (meta)packages.
  * These will provide the user a fully bootable system with proper shutdown/poweroff options.
  
 -- ProwlerGr <Prowler73@gmail.com>  Sat, 26 Apr 2025 22:22:22 +1000

dinit (0.19.3-0experimental2) UNRELEASED; urgency=medium

  * Fixed manpage conflicts.

 -- ProwlerGr <Prowler73@gmail.com>  Sat, 05 Apr 2025 22:22:22 +1000

dinit (0.19.3-0experimental1) UNRELEASED; urgency=medium

  * Updated to upstream 0.19.3 release.

 -- ProwlerGr <Prowler73@gmail.com>  Fri, 04 Apr 2025 22:22:22 +1000

dinit (0.19.1-2) unstable; urgency=medium

  * new build following ProwlerGR set up

 -- anticapitalista <antix@operamail.com>  Thu, 03 Apr 2025 21:03:50 +0300

=== debian/control ===
Source: dinit
Maintainer: Mobin Aydinfar <mobin@mobintestserver.ir>
Section: admin
Priority: optional
Standards-Version: 4.6.1.0
Build-Depends: 
 debhelper (>= 9), 
 debhelper-compat (= 13), 
 g++ (>= 4.9), m4, 
 dh-exec,
Homepage: https://davmac.org/projects/dinit
Vcs-Browser: https://salsa.debian.org/mobin2008/dinit
Vcs-Git: https://salsa.debian.org/mobin2008/dinit.git
Rules-Requires-Root: no

Package: dinit
Architecture: any
Depends:
 ${misc:Depends}, 
 ${shlibs:Depends},
Provides: dinit,
Recommends: 
 dinit-init-diversity | dinit-init, 
 dinit-service-boot-module | dinit-core-services-antix,
Description: Dinit service monitoring / "init" system
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits. Development goals include
 clean design, robustness, portability, usability,
 and avoiding feature bloat (whilst still handling
 common - and some less-common - use cases).
 Dinit is designed to integrate with rather than subsume or replace
 other system software.

Package: dinit-init
Architecture: any
Depends:
 ${misc:Depends}, 
 ${shlibs:Depends}, 
 dinit,
 dinit-service-boot-module | dinit-core-services-antix,
Recommends:
 dinit-service-dbus,
 dinit-service-seatd,
 dinit-service-slimski,
 dinit-service-connmand,
Breaks:
 sysvinit-core,
 runit-init,
Replaces:
 dinit-init-diversity,
 sysvinit-core,
 s6-rc-init,
 s6-66-init,
 runit-init,
 openrc-init,
Conflicts:
 dinit-init-diversity,
 s6-rc-init,
 s6-66-init,
 runit-init,
 openrc-init,
Description: This package installs dinit as the sole or default init system.
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 
Package: dinit-init-diversity
Architecture: any
Depends: 
 ${misc:Depends}, 
 ${shlibs:Depends},  
 dinit,
 init-diversity-tools,
 grub-init-diversity,
Recommends: 
 sysvinit-init-diversity,
 s6-rc-init-diversity,
 s6-66-init-diversity,
 openrc-init-diversity,
 runit-init-diversity,
 dinit-service-dbus,
 dinit-service-seatd,
 dinit-service-slimski,
 dinit-service-connmand,
Suggests:
 systemd-init-diversity,
Provides:
 dinit-init,
Replaces:
 dinit-init,
Breaks:
 dinit-init,
Conflicts:
 dinit-init,	
Description: This package allows for dinit to be installed alongside other inits.
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits.

## dinit 0.19.4

=== Makefile ===
--- 
+++ 
@@ -36,6 +36,5 @@
 	    echo "*** Found configuration for OS: $$UNAME"; \
 	    ln -sf "configs/mconfig.$$UNAME" mconfig; \
 	else \
-	    echo "*** No config available. Please create suitable mconfig file."; \
-	    exit 1; \
+	    ./configure; \
 	fi

=== meson_options.txt ===
## meson_options.txt for dinit
## You can set dinit's options in here:

## Please see BUILD_MESON for more information.

## General options
option(
    'shutdown-prefix',
    type : 'string',
    value : '',
    description : 'Name prefix for "shutdown", "halt", "soft-reboot" and "reboot" commands (if they are built).'
)
option(
    'dinit-control-socket-path',
    type : 'string',
    value : '/run/dinitctl',
    description : 'Default full path to the control socket, for when Dinit runs as system service manager.'
)
option(
    'unit-tests',
    type : 'boolean',
    value : false,
    description : 'Building Unit tests. by default its disabled.'
)
option(
    'igr-tests',
    type : 'boolean',
    value : false,
    description : 'Building Integration tests. by default its disabled.'
)
option(
    'fuzzer',
    type : 'boolean',
    value : false,
    description : 'Building fuzz target'
)
option(
    'use-utmpx',
    type : 'feature',
    value : 'auto',
    description : 'Whether to build support for manipulating the utmp/utmpx database via the related POSIX functions.'
)
option(
    'use-initgroups',
    type : 'boolean',
    value : true,
    description : 'Whether to use initgroups to initialize supplementary groups for run-as services.'
)
option(
    'dinit-sbindir',
    type : 'string',
    value : '/sbin',
    description : 'Default full path to the dinit executables. For some reasons dinit dont follow default sbindir. see BUILD_MESON for more info.'
)
option(
    'man-pages',
    type : 'boolean',
    value : true,
    description : 'Building & installing man-pages.'
)
option(
    'default-auto-restart',
    type : 'combo',
    choices : ['ALWAYS', 'ON_FAILURE', 'NEVER'],
    value : 'ALWAYS',
    description : 'Always/"on-failure"/never auto-restart for services by default. See BUILD_MESON for more info.'
)
option(
    'default-start-timeout',
    type : 'integer',
    value : 60,
    description : 'Default start-timeout for services in seconds'
)
option(
    'default-stop-timeout',
    type : 'integer',
    value : 10,
    description : 'Default stop-timeout for services in seconds'
)

## Linux specific options
option(
    'support-cgroups',
    type : 'feature',
    value : 'auto',
    description : 'Enable Cgroups supprot.'
)
option(
    'build-shutdown',
    type : 'feature',
    value : 'auto',
    description : 'Building shutdown/reboot/soft-reboot/halt or not.'
)

=== src/Makefile ===
include ../mconfig
include ../build/version.conf

STRIPOPTS ?= -s
ALL_CXXFLAGS=$(CPPFLAGS) $(CXXFLAGS) $(CXXFLAGS_EXTRA)
ALL_LDFLAGS=$(LDFLAGS) $(LDFLAGS_EXTRA)

ifeq ($(BUILD_SHUTDOWN),yes)
  SHUTDOWN=$(SHUTDOWN_PREFIX)shutdown
endif

dinit_objects = dinit.o load-service.o service.o proc-service.o baseproc-service.o control.o dinit-log.o \
		dinit-main.o run-child-proc.o options-processing.o dinit-env.o settings.o

objects = $(dinit_objects) dinitctl.o dinitcheck.o shutdown.o dinit-monitor.o

all: dinit dinitctl dinitcheck dinit-monitor $(SHUTDOWN)

../mconfig:
	@echo "*** No mconfig, please run make from top level"
	@false

dinit: $(dinit_objects)
	$(CXX) -o dinit $(dinit_objects) $(ALL_LDFLAGS)

dinitctl: dinitctl.o options-processing.o settings.o
	$(CXX) -o dinitctl dinitctl.o options-processing.o settings.o $(ALL_LDFLAGS)

dinitcheck: dinitcheck.o options-processing.o settings.o
	$(CXX) -o dinitcheck dinitcheck.o options-processing.o settings.o $(ALL_LDFLAGS)

dinit-monitor: dinit-monitor.o
	$(CXX) -o dinit-monitor dinit-monitor.o $(ALL_LDFLAGS)

$(SHUTDOWN_PREFIX)shutdown: shutdown.o
	$(CXX) -o $(SHUTDOWN_PREFIX)shutdown shutdown.o $(ALL_LDFLAGS)

$(objects): ../build/includes/mconfig.h

$(objects): %.o: %.cc
	$(CXX) $(ALL_CXXFLAGS) -MMD -MP -Iincludes -I../dasynq/include -I../build/includes -c $< -o $@

check: ../build/includes/mconfig.h $(dinit_objects)
	$(MAKE) -C tests check

check-igr: dinit dinitctl dinitcheck
	$(MAKE) -C igr-tests check-igr

run-cppcheck:
	cppcheck --std=c++11 -Iincludes -Idasynq --force --enable=all *.cc 2>../cppcheck-report.txt

install: all
	install -d $(DESTDIR)$(SBINDIR)
	install $(STRIPOPTS) dinit dinitctl dinitcheck dinit-monitor $(SHUTDOWN) $(DESTDIR)$(SBINDIR)
ifeq ($(BUILD_SHUTDOWN),yes)
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)halt
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)reboot
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)soft-reboot
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)poweroff
endif

clean:
	rm -f *.o *.d
	rm -f dinit dinitctl dinitcheck $(SHUTDOWN_PREFIX)shutdown dinit-monitor
	$(MAKE) -C tests clean
	$(MAKE) -C igr-tests clean

-include $(objects:.o=.d)

=== build/tools/Makefile ===
-include ../../mconfig

CXX_FOR_BUILD ?= $(CXX)
CXXFLAGS_FOR_BUILD ?= $(CXXFLAGS) $(CXXFLAGS_EXTRA)
CPPFLAGS_FOR_BUILD ?= $(CPPFLAGS)
LDFLAGS_FOR_BUILD ?= $(LDFLAGS) $(LDFLAGS_EXTRA)

mconfig-gen: mconfig-gen.cc
	$(CXX_FOR_BUILD) $(CPPFLAGS_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o mconfig-gen mconfig-gen.cc $(LDFLAGS_FOR_BUILD)

clean:
	rm -f mconfig-gen

=== doc/manpages/Makefile ===
--- 
+++ 
@@ -15,6 +15,7 @@
 	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)halt.8"
 	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)reboot.8"
 	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)poweroff.8"
+	ln -sf "$(SHUTDOWN_PREFIX)shutdown.8" "$(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)soft-reboot.8"
 endif
 
 clean:
@@ -24,10 +25,10 @@
 	./generate-html.sh
 
 dinit.8: dinit.8.m4
-	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit.8.m4 > dinit.8
+	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DSHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) dinit.8.m4 > dinit.8
 
 dinitctl.8: dinitctl.8.m4
-	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinitctl.8.m4 > dinitctl.8
+	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DSHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) dinitctl.8.m4 > dinitctl.8
 
 dinitcheck.8: dinitcheck.8.m4
 	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinitcheck.8.m4 > dinitcheck.8
@@ -36,7 +37,9 @@
 	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit-monitor.8.m4 > dinit-monitor.8
 
 dinit-service.5: dinit-service.5.m4
-	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit-service.5.m4 > dinit-service.5
+	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DDEFAULT_AUTO_RESTART=$(DEFAULT_AUTO_RESTART)\
+	   -DDEFAULT_START_TIMEOUT=$(DEFAULT_START_TIMEOUT)\
+	   -DDEFAULT_STOP_TIMEOUT=$(DEFAULT_STOP_TIMEOUT) dinit-service.5.m4 > dinit-service.5
 
 shutdown.8: shutdown.8.m4
-	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) shutdown.8.m4 > shutdown.8
+	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DSHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) shutdown.8.m4 > shutdown.8

=== src/igr-tests/Makefile ===
include ../../mconfig

check-igr: igr-runner
	mkdir -p igr-output
	IGR_OUTPUT_BASE=$$PWD/igr-output ./igr-runner

igr-runner: igr-runner.cc igr.h
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) $(CXXFLAGS_EXTRA) -I../../dasynq/include -I../../build/includes $(LDFLAGS) $(LDFLAGS_EXTRA) igr-runner.cc -o igr-runner

clean:
	rm -f igr-runner
	rm -rf */output/
	rm -rf reload1/sd
	rm -rf reload2/sd

=== src/tests/Makefile ===
-include ../../mconfig

ALL_TEST_CXXFLAGS=$(CPPFLAGS) $(TEST_CXXFLAGS) $(TEST_CXXFLAGS_EXTRA)
ALL_TEST_LDFLAGS=$(TEST_LDFLAGS) $(TEST_LDFLAGS_EXTRA)

objects = tests.o test-dinit.o proctests.o loadtests.o envtests.o test-run-child-proc.o test-bpsys.o
parent_objs = service.o proc-service.o dinit-log.o load-service.o baseproc-service.o dinit-env.o control.o settings.o

check: build-tests run-tests

build-tests: tests proctests loadtests envtests
	$(MAKE) -C cptests build-tests

run-tests: build-tests
	./tests
	./proctests
	./loadtests
	./envtests
	$(MAKE) -C cptests run-tests

tests: $(parent_objs) tests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o tests $(parent_objs) tests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS)

proctests: $(parent_objs) proctests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o proctests $(parent_objs) proctests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS)
	
loadtests: $(parent_objs) loadtests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o loadtests $(parent_objs) loadtests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS)

envtests: $(parent_objs) envtests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o envtests $(parent_objs) envtests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS)

$(objects): %.o: %.cc
	$(CXX) $(ALL_TEST_CXXFLAGS) -MMD -MP -Itest-includes -I../../dasynq/include -I../../build/includes -I../includes -c $< -o $@

$(parent_objs): %.o: ../%.cc
	$(CXX) $(ALL_TEST_CXXFLAGS) -MMD -MP -Itest-includes -I../../dasynq/include -I../../build/includes -I../includes -c $< -o $@

clean:
	$(MAKE) -C cptests clean
	rm -f *.o *.d tests proctests loadtests envtests

-include $(objects:.o=.d)
-include $(parent_objs:.o=.d)

=== src/tests/cptests/Makefile ===
-include ../../../mconfig

ALL_TEST_CXXFLAGS=$(CPPFLAGS) $(TEST_CXXFLAGS) $(TEST_CXXFLAGS_EXTRA)
ALL_TEST_LDFLAGS=$(TEST_LDFLAGS) $(TEST_LDFLAGS_EXTRA)

objects = cptests.o
parent_test_objects = ../test-bpsys.o ../test-dinit.o ../test-run-child-proc.o
parent_objs = control.o dinit-log.o service.o load-service.o proc-service.o baseproc-service.o dinit-env.o settings.o

check: build-tests run-tests

build-tests: cptests

run-tests: cptests
	./cptests

cptests: cptests.o $(parent_objs:%=../%) $(parent_test_objects)
	$(CXX) -o cptests cptests.o $(parent_test_objects) $(parent_objs:%=../%) $(ALL_TEST_LDFLAGS)

$(objects): %.o: %.cc
	$(CXX) $(ALL_TEST_CXXFLAGS) -MMD -MP -I../test-includes -I../../../dasynq/include -I../../../build/includes -I../../includes -c $< -o $@

clean:
	rm -f *.o *.d cptests


# Experimental LLVM-libFuzzer based fuzzer. "make fuzz" to build; "fuzz corpus" to run (and store
# interesting test data in "corpus" directory).

fuzz_parent_test_objects = $(foreach obj,$(notdir $(parent_test_objects)),fuzz-$(obj))
fuzz_objects = $(foreach obj,$(parent_objs),fuzz-$(obj))

# Create mconfig.h for fuzzing. because fuzz target not runned by top level make; we need to create mconfig.h manually.
../../../mconfig:
	$(MAKE) -C ../../../ mconfig

../../../build/includes/mconfig.h: ../../../mconfig
	$(MAKE) -C ../../../build all

fuzz: ../../../build/includes/mconfig.h fuzz.cc $(fuzz_parent_test_objects) $(fuzz_objects)
	clang++ -std=c++11 -g -O1 -I../test-includes -I../../../dasynq/include -I../../../build/includes/ -I../../includes -fsanitize=fuzzer,address,undefined,leak fuzz.cc $(fuzz_parent_test_objects) $(fuzz_objects) $(LDFLAGS_LIBCAP) -o fuzz

$(fuzz_parent_test_objects): fuzz-%.o: ../%.cc
	clang -O1 -fsanitize=address,undefined,fuzzer-no-link,leak -MMD -MP -I../test-includes -I../../../dasynq/include -I../../../build/includes/ -I../../includes -c $< -o $@

$(fuzz_objects): fuzz-%.o: ../../%.cc
	clang -O1 -fsanitize=address,undefined,fuzzer-no-link,leak -MMD -MP -I../test-includes -I../../../dasynq/include -I../../../build/includes/ -I../../includes -c $< -o $@


-include $(objects:.o=.d)
-include $(parent_objects:.o=.d)

=== debian/changelog ===
dinit (0.19.4-0antix6) unstable; urgency=medium

  * fix maintainer script errors on live frugal - thanks ProwlerGR

 -- anticapitalista <antix@operamail.com>  Wed, 22 Oct 2025 14:34:24 +0300

dinit (0.19.4-0antix5) unstable; urgency=medium

  * /usr/lib/dinit/dinit  /usr/sbin/dinit - link

 -- anticapitalista <antix@operamail.com>  Wed, 15 Oct 2025 14:19:19 +0300

dinit (0.19.4-0antix4) unstable; urgency=medium

  * don't update grub in chroot

 -- anticapitalista <antix@operamail.com>  Wed, 08 Oct 2025 15:01:39 +0300

dinit (0.19.4-0antix3) unstable; urgency=medium

  * package init-diversity as antix

 -- anticapitalista <antix@operamail.com>  Mon, 06 Oct 2025 18:47:06 +0300

dinit (0.19.4-0antix2) unstable; urgency=medium

  * Updated maintaner scripts to skip update-grub on Live/Frugal systems

 -- anticapitalista <antix@operamail.com>  Fri, 03 Oct 2025 18:55:35 +0300

dinit (0.19.4-0antix1) unstable; urgency=medium

  * sync with ProwlerGr
  * allow for option to install alongside other inits or not

 -- anticapitalista <antix@operamail.com>  Sun, 24 Aug 2025 12:57:51 +0300

dinit (0.19.4-0) unstable; urgency=medium

  * Updated to upstream 0.19.4 release.

 -- anticapitalista <antix@operamail.com>  Tue, 13 May 2025 23:24:26 +0300

dinit (0.19.3-0) unstable; urgency=medium

  * Updated to upstream 0.19.3 release.
  * Fix manpages conflict

 -- anticapitalista <antix@operamail.com>  Fri, 04 Apr 2025 16:21:52 +0300

=== debian/control ===
Source: dinit
Maintainer: Mobin Aydinfar <mobin@mobintestserver.ir>
Section: init-diversity
Priority: optional
Standards-Version: 4.6.1.0
Build-Depends: 
 debhelper (>= 9),
 debhelper-compat (= 13),
 g++ (>= 4.9),
 m4,
Homepage: https://davmac.org/projects/dinit
Vcs-Browser: https://gitlab.com/init-diversity/dinit/dinit-init-diversity
Vcs-Git: https://gitlab.com/init-diversity/dinit/dinit-init-diversity.git
Rules-Requires-Root: no

Package: dinit
Architecture: any
Depends: 
 ${misc:Depends}, 
 ${shlibs:Depends},
Provides: dinit,
Recommends: 
 dinit-init-antix | dinit-init, 
Description: Dinit service monitoring / "init" system
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits. Development goals include
 clean design, robustness, portability, usability,
 and avoiding feature bloat (whilst still handling
 common - and some less-common - use cases).
 Dinit is designed to integrate with rather than subsume or replace
 other system software.

Package: dinit-init
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 dinit,
 dinit-service-boot-module-antix,
Replaces:
 sysvinit-core,
 s6-rc-init,
 s6-66-init,
 openrc-init,
 runit-init,
Description: This package installs dinit as the sole or default init system.
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits. 
 
Package: dinit-init-antix
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 dinit,
 dinit-service-boot-module-antix,
 init-diversity-tools,
 grub-init-diversity,
Recommends:
 sysvinit-init-antix,
 runit-init-antix,
 openrc-init-antix,
 s6-rc-init-antix,
 s6-66-init-antix,
 dinit-dialogbox-manager,
Description: This package allows for dinit to be installed alongside other inits.
 Dinit is a service supervisor with dependency support
 which can also act as the system "init" program.
 It was created with the intention of providing a portable
 init system with dependency management, that was functionally
 superior to many extant inits.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
       https://github.com/davmac314/dinit/tags \
       (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## dinit 0.20.0

=== build/Makefile ===
--- 
+++ 
@@ -9,12 +9,15 @@
 
 includes/mconfig.h: ../mconfig tools/mconfig-gen.cc version.conf
 	$(MAKE) -C tools mconfig-gen
-	./tools/mconfig-gen SBINDIR=$(SBINDIR) SYSCONTROLSOCKET=$(SYSCONTROLSOCKET) \
+	./tools/mconfig-gen BINDIR=$(BINDIR) SBINDIR=$(SBINDIR) SYSCONTROLSOCKET=$(SYSCONTROLSOCKET) \
 		SHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) VERSION=$(VERSION) \
 		DEFAULT_AUTO_RESTART=$(DEFAULT_AUTO_RESTART) \
 		DEFAULT_START_TIMEOUT=$(DEFAULT_START_TIMEOUT) \
 		DEFAULT_STOP_TIMEOUT=$(DEFAULT_STOP_TIMEOUT) \
 		$(if $(SUPPORT_CGROUPS),SUPPORT_CGROUPS=$(SUPPORT_CGROUPS),) \
+		$(if $(SUPPORT_CAPABILITIES),SUPPORT_CAPABILITIES=$(SUPPORT_CAPABILITIES),) \
+		$(if $(SUPPORT_IOPRIO),SUPPORT_IOPRIO=$(SUPPORT_IOPRIO),) \
+		$(if $(SUPPORT_OOM_ADJ),SUPPORT_OOM_ADJ=$(SUPPORT_OOM_ADJ),) \
 		$(if $(USE_UTMPX),USE_UTMPX=$(USE_UTMPX),) \
 		$(if $(USE_INITGROUPS),USE_INITGROUPS=$(USE_INITGROUPS),) > includes/mconfig.h

=== src/Makefile ===
include ../mconfig
include ../build/version.conf

STRIPOPTS ?= -s
ALL_CXXFLAGS=$(CPPFLAGS) $(CXXFLAGS) $(CXXFLAGS_EXTRA)
ALL_LDFLAGS=$(LDFLAGS) $(LDFLAGS_EXTRA)

ifeq ($(BUILD_SHUTDOWN),yes)
  SHUTDOWN=$(SHUTDOWN_PREFIX)shutdown
endif

dinit_objects = dinit.o load-service.o service.o proc-service.o baseproc-service.o control.o dinit-log.o \
		dinit-main.o run-child-proc.o options-processing.o dinit-env.o settings.o dinit-iostream.o

objects = $(dinit_objects) dinitctl.o dinit-check.o shutdown.o dinit-monitor.o dinit-client.o

all: dinit dinitctl dinit-check dinit-monitor $(SHUTDOWN)

../mconfig:
	@echo "*** No mconfig, please run make from top level"
	@false

dinit: $(dinit_objects)
	$(CXX) -o dinit $(dinit_objects) $(ALL_LDFLAGS) $(LDFLAGS_LIBCAP)

dinitctl: dinitctl.o options-processing.o settings.o dinit-iostream.o dinit-client.o
	$(CXX) -o dinitctl dinitctl.o options-processing.o settings.o dinit-iostream.o dinit-client.o $(ALL_LDFLAGS)

dinit-check: dinit-check.o options-processing.o settings.o dinit-iostream.o dinit-client.o
	$(CXX) -o dinit-check dinit-check.o options-processing.o settings.o dinit-iostream.o dinit-client.o $(ALL_LDFLAGS) $(LDFLAGS_LIBCAP)

dinit-monitor: dinit-monitor.o
	$(CXX) -o dinit-monitor dinit-monitor.o $(ALL_LDFLAGS)

$(SHUTDOWN_PREFIX)shutdown: shutdown.o
	$(CXX) -o $(SHUTDOWN_PREFIX)shutdown shutdown.o $(ALL_LDFLAGS)

$(objects): ../build/includes/mconfig.h

$(objects): %.o: %.cc
	$(CXX) $(ALL_CXXFLAGS) -MMD -MP -Iincludes -I../dasynq/include -I../build/includes -c $< -o $@

check: ../build/includes/mconfig.h $(dinit_objects)
	$(MAKE) -C tests check

check-igr: dinit dinitctl dinit-check
	$(MAKE) -C igr-tests check-igr

run-cppcheck:
	cppcheck --std=c++11 -Iincludes -Idasynq --force --enable=all *.cc 2>../cppcheck-report.txt

install: all
	install -d $(DESTDIR)$(BINDIR)
	install $(STRIPOPTS) dinit dinitctl dinit-check dinit-monitor $(DESTDIR)$(BINDIR)
ifeq ($(BUILD_SHUTDOWN),yes)
	install -d $(DESTDIR)$(SBINDIR)
	install $(STRIPOPTS) $(SHUTDOWN) $(DESTDIR)$(SBINDIR)
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)halt
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)reboot
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)soft-reboot
	ln -sf $(SHUTDOWN) $(DESTDIR)$(SBINDIR)/$(SHUTDOWN_PREFIX)poweroff
endif

clean:
	rm -f *.o *.d
	rm -f dinit dinitctl dinit-check $(SHUTDOWN_PREFIX)shutdown dinit-monitor
	$(MAKE) -C tests clean
	$(MAKE) -C igr-tests clean

-include $(objects:.o=.d)

=== doc/manpages/Makefile ===
include ../../mconfig
include ../../build/version.conf

all: generate

generate: dinit.8 dinitctl.8 dinit-check.8 dinit-monitor.8 dinit-service.5 shutdown.8

install: generate
	mkdir -p $(DESTDIR)$(MANDIR)/man8
	install -m644 dinit.8 dinitctl.8 dinit-check.8 dinit-monitor.8 $(DESTDIR)$(MANDIR)/man8
	mkdir -p $(DESTDIR)$(MANDIR)/man5
	install -m644 dinit-service.5 $(DESTDIR)$(MANDIR)/man5
ifeq ($(BUILD_SHUTDOWN),yes)
	install -m644 shutdown.8 $(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)shutdown.8
	ln -sf $(SHUTDOWN_PREFIX)shutdown.8 $(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)halt.8
	ln -sf $(SHUTDOWN_PREFIX)shutdown.8 $(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)reboot.8
	ln -sf $(SHUTDOWN_PREFIX)shutdown.8 $(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)poweroff.8
	ln -sf $(SHUTDOWN_PREFIX)shutdown.8 $(DESTDIR)$(MANDIR)/man8/$(SHUTDOWN_PREFIX)soft-reboot.8
endif

clean:
	rm -f dinit.8 dinitctl.8 dinit-check.8 dinit-monitor.8 dinit-service.5 shutdown.8

html: generate
	./generate-html.sh

dinit.8: dinit.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DSHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) dinit.8.m4 > dinit.8

dinitctl.8: dinitctl.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DSHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) dinitctl.8.m4 > dinitctl.8

dinit-check.8: dinit-check.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit-check.8.m4 > dinit-check.8

dinit-monitor.8: dinit-monitor.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) dinit-monitor.8.m4 > dinit-monitor.8

dinit-service.5: dinit-service.5.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DDEFAULT_AUTO_RESTART=$(DEFAULT_AUTO_RESTART)\
	   -DDEFAULT_START_TIMEOUT=$(DEFAULT_START_TIMEOUT)\
	   -DDEFAULT_STOP_TIMEOUT=$(DEFAULT_STOP_TIMEOUT) dinit-service.5.m4 > dinit-service.5

shutdown.8: shutdown.8.m4
	m4 -DVERSION=$(VERSION) -DMONTH=$(MONTH) -DYEAR=$(YEAR) -DSHUTDOWN_PREFIX=$(SHUTDOWN_PREFIX) shutdown.8.m4 > shutdown.8

=== src/tests/Makefile ===
-include ../../mconfig

ALL_TEST_CXXFLAGS=$(CPPFLAGS) $(TEST_CXXFLAGS) $(TEST_CXXFLAGS_EXTRA)
ALL_TEST_LDFLAGS=$(TEST_LDFLAGS) $(TEST_LDFLAGS_EXTRA)

objects = tests.o test-dinit.o proctests.o loadtests.o envtests.o iostreamtests.o test-run-child-proc.o test-bpsys.o
parent_objs = service.o proc-service.o dinit-log.o load-service.o baseproc-service.o dinit-env.o control.o settings.o \
	dinit-iostream.o
check: build-tests run-tests

build-tests: tests proctests loadtests envtests iostreamtests
	$(MAKE) -C cptests build-tests

run-tests: build-tests
	./tests
	./proctests
	./loadtests
	./envtests
	./iostreamtests
	$(MAKE) -C cptests run-tests

tests: $(parent_objs) tests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o tests $(parent_objs) tests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS) $(LDFLAGS_LIBCAP)

proctests: $(parent_objs) proctests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o proctests $(parent_objs) proctests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS) $(LDFLAGS_LIBCAP)
	
loadtests: $(parent_objs) loadtests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o loadtests $(parent_objs) loadtests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS) $(LDFLAGS_LIBCAP)

envtests: $(parent_objs) envtests.o test-dinit.o test-bpsys.o test-run-child-proc.o
	$(CXX) -o envtests $(parent_objs) envtests.o test-dinit.o test-bpsys.o test-run-child-proc.o $(ALL_TEST_LDFLAGS) $(LDFLAGS_LIBCAP)

iostreamtests: iostreamtests.o dinit-iostream.o test-bpsys.o
	$(CXX) -o iostreamtests iostreamtests.o dinit-iostream.o test-bpsys.o $(ALL_TEST_LDFLAGS)

$(objects): %.o: %.cc
	$(CXX) $(ALL_TEST_CXXFLAGS) -MMD -MP -Itest-includes -I../../dasynq/include -I../../build/includes -I../includes -c $< -o $@

$(parent_objs): %.o: ../%.cc
	$(CXX) $(ALL_TEST_CXXFLAGS) -MMD -MP -Itest-includes -I../../dasynq/include -I../../build/includes -I../includes -c $< -o $@

clean:
	$(MAKE) -C cptests clean
	rm -f *.o *.d tests proctests loadtests envtests iostreamtests

-include $(objects:.o=.d)
-include $(parent_objs:.o=.d)

=== src/tests/cptests/Makefile ===
--- 
+++ 
@@ -5,7 +5,8 @@
 
 objects = cptests.o
 parent_test_objects = ../test-bpsys.o ../test-dinit.o ../test-run-child-proc.o
-parent_objs = control.o dinit-log.o service.o load-service.o proc-service.o baseproc-service.o dinit-env.o settings.o
+parent_objs = control.o dinit-log.o service.o load-service.o proc-service.o baseproc-service.o dinit-env.o \
+	settings.o dinit-iostream.o
 
 check: build-tests run-tests
 
@@ -15,7 +16,7 @@
 	./cptests
 
 cptests: cptests.o $(parent_objs:%=../%) $(parent_test_objects)
-	$(CXX) -o cptests cptests.o $(parent_test_objects) $(parent_objs:%=../%) $(ALL_TEST_LDFLAGS)
+	$(CXX) -o cptests cptests.o $(parent_test_objects) $(parent_objs:%=../%) $(ALL_TEST_LDFLAGS) $(LDFLAGS_LIBCAP)
 
 $(objects): %.o: %.cc
 	$(CXX) $(ALL_TEST_CXXFLAGS) -MMD -MP -I../test-includes -I../../../dasynq/include -I../../../build/includes -I../../includes -c $< -o $@

=== debian/changelog ===
dinit (0.20.0-0experimental1) UNRELEASED; urgency=medium

  * update to 0.20.0

 -- ProwlerGr <Prowler73@gmail.com>  Sat, 15 Nov 2025 22:22:22 +1000

dinit (0.19.4-0experimental3) UNRELEASED; urgency=medium

  * Updated maintaner scripts to skip update-grub on Live/Frugal systems

 -- ProwlerGr <Prowler73@gmail.com>  Fri, 03 Oct 2025 22:22:22 +1000

dinit (0.19.4-0experimental2) UNRELEASED; urgency=medium

  * Resolved dependencies after official antiX boot module created..
  
 -- ProwlerGr <Prowler73@gmail.com>  Sat, 24 May 2025 22:22:22 +1000

dinit (0.19.4-0experimental1) UNRELEASED; urgency=medium

  * Updated to upstream 0.19.4 release.
  
 -- ProwlerGr <Prowler73@gmail.com>  Sat, 10 May 2025 22:22:22 +1000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: dinit
-Maintainer: Mobin Aydinfar <mobin@mobintestserver.ir>
+Maintainer: ProwlerGr <Prowler73@gmail.com>
 Section: init-diversity
 Priority: optional
 Standards-Version: 4.6.1.0
@@ -20,7 +20,7 @@
  ${shlibs:Depends},
 Provides: dinit,
 Recommends: 
- dinit-init-antix | dinit-init, 
+ dinit-init-diversity | dinit-init-antix | dinit-init, 
 Description: Dinit service monitoring / "init" system
  Dinit is a service supervisor with dependency support
  which can also act as the system "init" program.
@@ -39,7 +39,7 @@
  ${misc:Depends},
  ${shlibs:Depends},
  dinit,
- dinit-service-boot-module-antix,
+ dinit-service-boot-module | dinit-service-boot-module-antix,
 Replaces:
  sysvinit-core,
  s6-rc-init,
@@ -53,21 +53,21 @@
  init system with dependency management, that was functionally
  superior to many extant inits. 
  
-Package: dinit-init-antix
+Package: dinit-init-diversity
 Architecture: any
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  dinit,
- dinit-service-boot-module-antix,
+ dinit-service-boot-module | dinit-service-boot-module-antix,
  init-diversity-tools,
  grub-init-diversity,
 Recommends:
- sysvinit-init-antix,
- runit-init-antix,
- openrc-init-antix,
- s6-rc-init-antix,
- s6-66-init-antix,
+ sysvinit-init-diversity,
+ runit-init-diversity,
+ openrc-init-diversity,
+ s6-rc-init-diversity,
+ s6-66-init-diversity,
  dinit-dialogbox-manager,
 Description: This package allows for dinit to be installed alongside other inits.
  Dinit is a service supervisor with dependency support

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CONFIG_OPT += --prefix=/usr
CONFIG_OPT += --exec-prefix=/usr
CONFIG_OPT += --bindir=/usr/bin
CONFIG_OPT += --sbindir=/usr/sbin
CONFIG_OPT += --mandir=/usr/share/man
CONFIG_OPT += --syscontrolsocket=/run/dinitctl

%:
	dh $@

override_dh_clean:
	if test -e README.md; then rm README.md; fi;
	if test -e config.mak; then rm config.mak; fi;
	dh_clean
	
override_dh_auto_clean:
	touch ./mconfig

override_dh_auto_configure:
	./configure -- $(CONFIG_OPT)
